/* Creo tantas tareas como nodos para recorrer el arbol en paralelo */
int BuscarSeq(Node *node, int inf) {
  if (node==NULL) return FALSE;
  else if (inf == node->inf) return TRUE;
  else {
    nTask task1 = nEmitTask(BuscarSeq, node->left, inf);
    nTask task2 = nEmitTask(BuscarSeq, node->right, inf);
    return nWaitTask(task1) || nWaitTask(task2);
  }
}

/* Creo tantas tareas como procesadores. Una vez que complete mi nivel 
 * de procesadores, recorro secuencialmente */
int BuscarSeq(Node *node, int inf, int level) {
  if (node==NULL) return FALSE;
  else if (inf == node->inf) return TRUE;
  else {
    if (level > 6) {
      return BuscarSeq(node->left, inf, level+1) ||
             BuscarSeq(node->right, inf, level+1);
    }
    else {
      nTask task1 = nEmitTask(BuscarSeq, node->left, inf, level+1);
      nTask task2 = nEmitTask(BuscarSeq, node->right, inf, level+1);
      int r1 = nWaitTask(task1);
      int r2 = nWaitTask(task2);
      return r1 || r2;
    }
  }
}

/* Cuando encuentre el elemento las demas tareas terminan su ejecucion.  */
int BuscarSeq(Node *node, int inf, int level, int *pFOUND) {
  if (node==NULL) return FALSE;
  else if (*pFOUND) return TRUE;
  else if (inf == node->inf) {
    *pFOUND = TRUE;
    return TRUE;
  }
  else {
    if (level > 6) {
      return BuscarSeq(node->left, inf, level+1, pFOUND) ||
             BuscarSeq(node->right, inf, level+1, pFOUND);
    }
    else {
      nTask task1 = nEmitTask(BuscarSeq, node->left, inf, level+1, pFOUND);
      nTask task2 = nEmitTask(BuscarSeq, node->right, inf, level+1, pFOUND);
      int r1 = nWaitTask(task1);
      int r2 = nWaitTask(task2);
      return r1 || r2;
} } }
